strncpy(3)

NAME
strncpy - nonstring copy

LIBRARY
Standard C library (libc, -lc)

SYNOPSIS
#include <string.h>  // see memory.h(3head)

char *strncpy(size_t dsize;
              char dst[restrict dsize], const char *restrict src,
              size_t dsize);

DESCRIPTION
This function copies non-null characters from the string pointed to by src into the array pointed to by dst. If the source has too few non-null bytes to fill the destination, it pads the destination with trailing null bytes. If the destination buffer, limited by its size, isn't large enough to hold the copy, the resulting character sequence is truncated.

It is equivalent to

    stpncpy(dst, src, dsize), dst

RETURN VALUE
dst.

ATTRIBUTES
For an explanation of the terms used in this section, see attributes(7).
Interface | Attribute | Value
 | Thread safety | MT-Safe

STANDARDS
C11, POSIX.1-2008.

HISTORY
C89, POSIX.1-2001, SVr4, 4.3BSD.

CAVEATS
The name of this function is confusing. This function produces a null-padded character sequence, not a string (see string_copying(7)). For example:

    strncpy(buf, "1", 5);       // { '1',   0,   0,   0,   0 }
    strncpy(buf, "1234", 5);    // { '1', '2', '3', '4',   0 }
    strncpy(buf, "12345", 5);   // { '1', '2', '3', '4', '5' }
    strncpy(buf, "123456", 5);  // { '1', '2', '3', '4', '5' }

It's impossible to distinguish truncation by the result of the call, from a character sequence that just fits the destination buffer; truncation should be detected by comparing the length of the input string with the size of the destination buffer.

EXAMPLES
This function is intended to be used only for writing to fixed-width null-padded character arrays, such as those in utmp(5) members.

    strncpy(utmp->ut_user, "foo", countof(utmp->ut_user));

SEE ALSO
memory.h(3head), string_copying(7)